/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... kopirovaci konstruktor a operator =
*/

#include<iostream>
#include<string>
#include "Vektor1.h"
using namespace std;

class Vektor
{

	double *a;
	const int n;
public:
	Vektor(int _n) : n(_n)
	{
		cout << "konstruktor vektoru delky " << n << endl;
		a = new double[n];
		// inicializace:
		for (int i = 0; i < n; i++)
			a[i] = 0;
	}
	Vektor(Vektor &v) : n(v.n)
	{
		cout << "kopirovaci konstruktor vektoru delky " << n << endl;
		//a = v.a; // NE!
		a = new double[n];
		for (int i = 0; i < n; i++)
			a[i] = v.a[i];
	}
	Vektor& operator =(const Vektor &v)
	{
		for (int i = 0; (i < n) && (i < v.n); i++)
			a[i] = v.a[i];
		return *this;
	}
	double& operator [](int i)
	{
		if (i < 0 || i >= n)
			throw 1;
		return a[i];
	}
	void vypis()
	{
		for (int i = 0; i < n; i++)
			cout << a[i] << " ";
		cout << endl;
	}
	void nastav()
	{
		for (int i = 0; i < n; i++)
			a[i] = 1;
	}
	void pricti1(const Vektor &v)
	{
		for (int i = 0; (i < n) && (i < v.n); i++)
			a[i] += v.a[i];
	}
	void pricti(Vektor v)
	{
		for (int i = 0; (i < n) && (i < v.n); i++)
			a[i] += v.a[i];
	}
	~Vektor()
	{
		cout << "destruktor vektoru delky " << n << endl;
		delete[] a;
	}
};

Vektor c1(8);

int main()
{

	{
		Vektor a(4);
		a.nastav();
		cout << a[2] << endl;
		a[3] = 3;
		a.vypis();

		Vektor *b = new Vektor(6);
		b->vypis();
		delete b;

		// kopirovaci konstruktor:
		Vektor c(a);
		Vektor d = a; // totez
		c.pricti1(a);
		c.vypis();
		d.vypis();
		a.vypis();

		d = c;
		d.vypis();
		c.vypis();

		Vektor a1(5);
		a1.nastav();
		a1.vypis();
		a1.pricti(a);
		a1.vypis();
	}

	{
		Vektor1 a(4);
		a.nastav();
		cout << a[2] << endl;
		a[3] = 3;
		a.vypis();
		Vektor1 *b = new Vektor1(6);
		b->vypis();
		delete b;
		Vektor1 c(a);
		Vektor1 d = a; // totez
		c.pricti1(a);
		c.vypis();
		d.vypis();
		a.vypis();

		d = c;
		d.vypis();
		c.vypis();

		Vektor1 a1(5);
		a1.nastav();
		a1.vypis();
		a1.pricti(a);
		a1.vypis();
	}
	return 0;
}